package sgc.portal.cw.cw0101.service;

import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import sgc.portal.base.util.EasyHashMap;
import sgc.portal.base.websquare.GridRowStatus;
import sgc.portal.cw.cw0101.dto.CW01010001USearch;
import sgc.portal.cw.cw0101.model.CW01010001U;
import sgc.portal.cw.cw0101.persistence.CW01010001UMapper;
import sgc.portal.cw.cw0101.model.CW01010001U;

import java.time.LocalDateTime;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class CW01010001UService {
    private final CW01010001UMapper mapper;

    public CW01010001UService(CW01010001UMapper mapper) {
        this.mapper = mapper;
    }

    public List<EasyHashMap<String, Object>> getList(CW01010001USearch search) {
        return mapper.getList(search);
    }

    @Transactional
    public Map<String, String> save(List<CW01010001U> CW01010001U) {
    	
    	Map<String,String> result = new HashMap<>();
    	
    	for (CW01010001U cW01010001U : CW01010001U) {
            switch (cW01010001U.getRowStatus()) {
                case GridRowStatus.CREATED:
                    insert(cW01010001U);
                    break;
                case GridRowStatus.UPDATED:
                    update(cW01010001U);
                    break;
                case GridRowStatus.DELETED:
                    delete(cW01010001U);
                    break;
                default:
                    break;
            }
        }
    	return result;
    }

    private void insert(CW01010001U cW01010001U) {
        mapper.insert(cW01010001U);
    }

    private void update(CW01010001U cW01010001U) {
        mapper.update(cW01010001U);
    }

    private void delete(CW01010001U cW01010001U) {
        mapper.delete(cW01010001U);
    }
    
    @Transactional
    public Map<String, String> approve(List<CW01010001U> CW01010001U) {
    	
    	Map<String,String> result = new HashMap<>();
    	
        for (CW01010001U cW01010001U : CW01010001U) {
        	approve(cW01010001U);
        }
        return result;
    }
    
    private void approve(CW01010001U cW01010001U) {
        mapper.approve(cW01010001U);
    }
}
